#!/usr/local/bin/perl
#
#            @      _ _ _                      ,___                                   
#         @  |     ( / ) )                    /   //      o     _/_                  /
#      @  |  |      / / / _  _   _   __  ,   /    /_  _  ,  (   /  _ _ _   __,  (   / 
#   @  |  |  |     / / (_(/_/ (_/ (_/ (_/_  (___// /_/ (_(_/_)_(__/ / / /_(_/(_/_)_'  
#   |  |  |  |                         /                                          o   
# o>8<<<>8<>>8<o                      '                                               
#  \__________/     By:  Veronica Karlsson,  http://www.ludd.luth.se/users/vk/
#
# This perl script will light one more candle each Sunday until Christmas. On the
# last of those four Sundays the candles will gradually burn down and be turned
# out (the first at noon, the second at 16:00, the third at 20:00 and the fourth
# at midnight, Swedish time). At midnight all four candles will be out and the
# message "Merry Christmas and a happy New Year!" will appear. After New Year's
# eve it will go away and a new message will appear, saying simply "Happy New Year!"
# this message will stay during January, to give you some time to come back from
# the Christmas holidays and turn it off.
#
# For this script to work correctly you will have to set the variable $adv1.
# $adv1 = The date of the first Sunday in Advent;
#

$adv1 = 30;

#
# Nothing else needs to be changed.
#
########################################################################################

$adv2 = ($adv1 + 7) % 30;  # % is "mod"
$adv3 = $adv2 + 7;
$adv4 = $adv3 + 7;

@now=localtime(time);    # @now = {seconds, minutes, hours, date, month, year, ?, ?, ?}
$month = $now[4];
$date = $now[3];
$hour = $now[2];

# TEST!
# print "<BODY TEXT=FFFF66 LINK=66CC66 VLINK=7070FF bgcolor=black>\n";
# print "<center>";
# foreach $month (0 .. 11) { foreach $date (1 .. 31) {
# print "\nmonth $month  date $date  hour $hour\n\n";
# print "a1: $adv1\na2 $adv2\na3 $adv3\na4 $adv4\n";

if ($month == 10)
{
    if ($date > 24)
    {
	print "<pre><font size=\"+3\">";
	if (($date < $adv1) || ($adv1 < 15))
	{
	    print "<font color=\"\#666666\">  ,  ,  ,  ,  </font>\n";
	    print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	    print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	    print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	    print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	    print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
	    print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
	    print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
	    print "000\">8</font>&lt;</font>o\n";
	    print " \\__________/ </font>\n";
	}
	else
	{
	    if ($date == $adv1)
	    {
		print "<font color=\"\#ffff00\">  @</font><font color=\"\#c";
		print "ccccc\">  ,  ,  ,  </font>\n";
		print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
		print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
		print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
		print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
		print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
		print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
		print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
		print "000\">8</font>&lt;</font>o\n";
		print " \\__________/ </font>\n";
	    }
	    else
	    {
		print "<font color=\"\#666666\">     ,  ,  ,  </font>\n";
		print "<font color=\"\#666666\">  , </font><font color=\"\#f";
		print "fffff\"> |  |  |  </font>\n";
		print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
		print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
		print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
		print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
		print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
		print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
		print "000\">8</font>&lt;</font>o\n";
		print " \\__________/ </font>\n";
	    }
	}
	print "</font></pre>";
    }
}
if ($month == 11)
{
    print "<pre><font size=\"+3\">";
    if (($date < $adv1) && ($adv1 < 15))
    {
	print "<font color=\"\#666666\">  ,  ,  ,  ,  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
	print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
	print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
	print "000\">8</font>&lt;</font>o\n";
	print " \\__________/ </font>\n";
    }
    if (($date == $adv1) && ($adv1 < 15))
    {
	print "<font color=\"\#ffff00\">  @</font><font color=\"\#c";
	print "ccccc\">  ,  ,  ,  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
	print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
	print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
	print "000\">8</font>&lt;</font>o\n";
	print " \\__________/ </font>\n";
    }
    if ($adv1 > 15) { $adv1 = 0 }
    if (($date > $adv1) && ($date < $adv2))
    {
	print "<font color=\"\#666666\">     ,  ,  ,  </font>\n";
	print "<font color=\"\#666666\">  , </font><font color=\"\#f";
	print "fffff\"> |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
	print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
	print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
	print "000\">8</font>&lt;</font>o\n";
	print " \\__________/ </font>\n";
    }
    if ($date == $adv2)
    {
	print "<font color=\"\#ffff00\">     @ </font><font color=\"";
	print "\#666666\"> ,  ,  </font>\n";
	print "<font color=\"\#ffff00\">  @ </font><font color=\"\#f";
	print "fffff\"> |  |  |  </font>\n";
        print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
	print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
	print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
	print "000\">8</font>&lt;</font>o\n";
	print " \\__________/ </font>\n";	
    }
    if (($date > $adv2) && ($date < $adv3))
    {
	print "<font color=\"\#666666\">        ,  ,  </font>\n";
	print "<font color=\"\#666666\">     , </font><font color=\"";
	print "\#ffffff\"> |  |  </font>\n";
        print "<font color=\"\#666666\">  , </font><font color=\"\#f";
	print "fffff\"> |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
	print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
	print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
	print "000\">8</font>&lt;</font>o\n";
	print " \\__________/ </font>\n";
    }
    if ($date == $adv3)
    {
	print "<font color=\"\#ffff00\">        @</font><font color=";
	print "\"\#ffffff\">  ,  </font>\n";
	print "<font color=\"\#ffff00\">     @</font><font color=\"\#";
	print "ffffff\">  |  |  </font>\n";
        print "<font color=\"\#ffff00\">  @</font><font color=\"\#fff";
	print "fff\">  |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
	print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
	print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
	print "000\">8</font>&lt;</font>o\n";
	print" \\__________/ </font>\n";
    }
    if (($date > $adv3) && ($date < $adv4))
    {
	print "<font color=\"\#666666\">           ,  </font>\n";
	print "<font color=\"\#666666\">        , </font><font color=";
	print "\"\#ffffff\"> |  </font>\n";
        print "<font color=\"\#666666\">     , </font><font color=\"\#";
	print "ffffff\"> |  |  </font>\n";
	print "<font color=\"\#666666\">  , </font><font color=\"\#fff";
	print "fff\"> |  |  |  </font>\n";
	print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
	print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
	print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
	print "000\">8</font>&lt;</font>o\n";
	print " \\__________/ </font>\n";
    }
    if ($date == $adv4)
    {
	# TEST!
	# foreach $hour (0 .. 24) {
	
	if ($hour <= 12)
	{
	    print "<font color=\"\#ffff00\">           @  </font>\n";
	    print "<font color=\"\#ffff00\">        @ </font><font color";
	    print "=\"\#ffffff\"> |  </font>\n";
	    print "<font color=\"\#ffff00\">     @</font><font color=\"\#";
	    print "ffffff\">  |  |  </font>\n";
	    print "<font color=\"\#ffff00\">  @ </font><font color=\"\#ff";
	    print "ffff\"> |  |  |  </font>\n";
	    print "<font color=\"\#ffffff\">  |  |  |  |  </font>\n";
	    print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
	    print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
	    print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
	    print "000\">8</font>&lt;</font>o\n";
	    print " \\__________/ </font>\n";
	}
	if (($hour > 12) && ($hour <= 16))
	{
	    print "\n";
	    print "<font color=\"\#ffff00\">           @  </font>\n";
	    print "<font color=\"\#ffff00\">        @</font><font color=";
	    print "\"\#ffffff\">  |  </font>\n";
	    print "<font color=\"\#ffff00\">     @</font><font color=\"\#";
	    print "ffffff\">  |  |  </font>\n";
	    print "<font color=\"\#ffffff\">  i  |  |  |  </font>\n";
	    print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
	    print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
	    print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
	    print "000\">8</font>&lt;</font>o\n";
	    print " \\__________/ </font>\n";
	}
	if (($hour > 16) && ($hour <= 20))
	{
	    print "\n";
	    print "\n";
	    print "<font color=\"\#ffff00\">           @  </font>\n";
	    print "<font color=\"\#ffff00\">        @</font><font color=\"";
	    print "\#ffffff\">  |  </font>\n";
	    print "<font color=\"\#ffffff\">  i  i  |  |  </font>\n";
	    print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
	    print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
	    print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
	    print "000\">8</font>&lt;</font>o\n";
	    print " \\__________/ </font>\n";
	}
	if ($hour > 20)
	{
	    print"\n";
	    print"\n";
	    print"\n";
	    print"<font color=\"\#ffff00\">           @  </font>\n";
	    print"<font color=\"\#ffffff\">  i  i  i  |  </font>\n";
	    print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
	    print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
	    print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
	    print "000\">8</font>&lt;</font>o\n";
	    print" \\__________/ </font>\n";
	}
	# TEST!
	# } # for each hour
    }
    if ($date > $adv4)
    {
	print"<font color=\"\#ff0000\">Merry Christmas\n";
	print"     and a     \n";
        print"Happy New Year!</font>\n";
	print"\n";
	print"<font color=\"\#ffffff\">  i  i  i  i  </font>\n";
	print "<font color=\"\#ffff00\">o<font color=\"\#00ff00\">>";
	print "<font color=\"\#ff0000\">8</font>&lt;&lt;&lt;><font ";
	print "color=\"\#ff0000\">8</font>&lt;>><font color=\"\#ff0";
	print "000\">8</font>&lt;</font>o\n";
	print" \\__________/ </font>\n";
    }
    print "</font></pre>";
}
if ($month == 0)
{
    print "<pre><font size=\"+3\"><font color=\"\#ccccff\">*********";
    print "**************\n*                     *\n*   <font color=";
    print "\"\#ffffcc\">Happy New Year!</font>   *\n*               ";
    print "      *\n***********************</font></font></pre>"
}

# TEST!
# } }  # for each date, for each month
